﻿Imports System.Runtime.Serialization
Imports Windows.Storage

Public Class Session
    Shared sessions As List(Of ISession) = New List(Of ISession)()

    Public Shared Sub Register(session As ISession)
        sessions.Add(session)
    End Sub

    Public Shared Sub Unregister(session As ISession)
        sessions.Remove(session)
    End Sub

    Public Shared Sub Save()
        For Each session As ISession In sessions
            session.Save()
        Next
    End Sub

    Public Shared Sub Restore()
        For Each session As ISession In sessions
            session.Restore()
        Next
    End Sub

    Public Shared Async Sub Save(dataObject As Object)

        Dim file = Await ApplicationData.Current.LocalFolder.CreateFileAsync("dataObject.xml", CreationCollisionOption.ReplaceExisting)

        Using dataStream = Await file.OpenStreamForWriteAsync()
            Dim serializer = New DataContractSerializer(dataObject.GetType())
            serializer.WriteObject(dataStream, dataObject)
        End Using

    End Sub

    Public Shared Async Function Restore(typeObject As Type) As Task(Of Object)

        Using dataStream = Await ApplicationData.Current.LocalFolder.OpenStreamForReadAsync("dataObject.xml")
            Dim serializer = New DataContractSerializer(typeObject)
            Return serializer.ReadObject(dataStream)
        End Using

    End Function

End Class
