﻿
Imports Windows.UI.Core
Imports Windows.UI.Xaml.Shapes

Public NotInheritable Class MainPage
    Inherits Page

    Private _cursor As CoreCursor
    Private _x1, _x2, _y1, _y2 As Double
    Private _shape As Shape

    Sub New()

        InitializeComponent()
        _cursor = Window.Current.CoreWindow.PointerCursor

    End Sub

    Private Sub Canvas_PointerPressed(sender As Object, e As PointerRoutedEventArgs)
        Window.Current.CoreWindow.PointerCursor = New CoreCursor(CoreCursorType.Cross, 1)

        _x1 = e.GetCurrentPoint(canvas).Position.X
        _y1 = e.GetCurrentPoint(canvas).Position.Y
        _x2 = _x1
        _y2 = _y1

        _shape = New Ellipse()

        _shape.Width = _x2 - _x1
        _shape.Height = _y2 - _y1
        _shape.StrokeThickness = 3

        _shape.Stroke = New SolidColorBrush(Windows.UI.Colors.Blue)
        _shape.Fill = New SolidColorBrush(Windows.UI.Colors.Red)

        canvas.Children.Add(_shape)

    End Sub

    Private Sub Canvas_PointerMoved(sender As Object, e As PointerRoutedEventArgs)

        If _shape Is Nothing Then
            Return
        End If

        _x2 = e.GetCurrentPoint(canvas).Position.X
        _y2 = e.GetCurrentPoint(canvas).Position.Y

        Canvas.SetLeft(_shape, If(_x2 > _x1, _x1, _x2))

        Canvas.SetTop(_shape, If(_y2 > _y1, _y1, _y2))

        _shape.Width = Math.Abs(_x2 - _x1)
        _shape.Height = Math.Abs(_y2 - _y1)

    End Sub

    Private Sub Canvas_PointerReleased(sender As Object, e As PointerRoutedEventArgs)

        _shape = Nothing
        Window.Current.CoreWindow.PointerCursor = _cursor

    End Sub

End Class
