﻿Imports Windows.Storage
Imports Windows.Storage.FileProperties

Namespace PictureLibrary

    Public Class Image
        Public Property Name As String
        Public Property BitmapImage As BitmapImage
        Public Property DateCreated As DateTimeOffset
        Public Property Path As String
        Public Property FileType As String
    End Class

    Public Class ImageList
        Inherits ObservableCollection(Of Image)

        Sub New()
            update()
        End Sub

        Private Async Sub update()
            Dim pictureFolder As StorageFolder = KnownFolders.PicturesLibrary

            Dim fileList As IReadOnlyList(Of StorageFile)
            fileList = Await pictureFolder.GetFilesAsync()

            For Each f In fileList
                Dim thumbnail As StorageItemThumbnail
                thumbnail = Await f.GetThumbnailAsync(
                    ThumbnailMode.PicturesView,
                    250, ThumbnailOptions.ResizeThumbnail)

                Dim image = New BitmapImage

                image.SetSource(thumbnail)

                Add(New Image With
                {
                    .BitmapImage = image,
                    .Name = f.Name,
                    .DateCreated = f.DateCreated,
                    .FileType = f.DisplayType,
                    .Path = f.Path
                })
            Next
        End Sub
    End Class

End Namespace